
;Stormtrooper track to file routine by KrazyKato


;You must have a Pasit image of the game for this to work.
;Read the stormtrooper disk and save each track as a file based on the (hex) track number.
;The original game code is used to read the tracks into the buffer.
;Assumes you are using a hard drive to save the files to.
;This all works fine under STeem.


	clr.l	-(a7)
	move.w	#32,-(a7)
	trap	#1			;Enter supervisor mode
	addq.l	#6,a7
 	move.l	d0,old_sp
	move.w	#$2700,sr		;Interrupts disabled
	
	lea	gamecode(pc),a0		;The decrypted game code
	lea	$80200,a1		;Relocate to here - makes it easier
	move.l	#codend-gamecode,d0	;Length of code
relo	move.b	(a0)+,(a1)+		;Copy it up
	dbra	d0,relo
	

	lea	buffer,a2
	lea	buffer,a0		;My save buffer
	move.l	a0,a3			;Copy the buffer address
	moveq	#6,d0			;Start track
	
	*********************************************	

readtrack:
	movem.l	d0-a6,-(a7)		;Save registers

	jsr	$87970			;Sector loading code from game. d0=track / a0 = address
					;This will read and decrypt the track to the save buffer

	movem.l	(a7)+,d0-a6		;Restore registers
	bsr	savefile		;Create filename and save data of 5632 bytes
      	cmp.w	#-1,d0			;Test for error
	beq	exit
next	addq	#1,d0			;Increment track number	
	cmp.b	#29,d0			;Bad track (disk check)
	beq	next
	cmp.b	#40,d0			;Bad track (disk check)
	beq	next	
	cmp.b	#62,d0			;Bad track (disk check)
	beq	next
	cmp.b   #79,d0 			;Reached the last track yet?
	bls     readtrack		;Keep reading tracks

exit	move.l	old_sp,-(a7)		;Restore
	move.w	#32,-(a7)
	trap	#1
	addq.l	#6,a7

	clr.w	-(A7)			;Quit !
	trap	#1



;Each track is saved here to the hdd 


savefile				;A3 = save address
	movem.l	d0-a6,-(A7)		;Save registers
	bsr	doname			;Generate the file name
	move.l	#5632,d7		;Length to save
	lea	name(pc),a5		;Pass the file name
	move.l	a3,a4			;Address to save from
	bsr	create			;Create the file now
	tst.l	d0			;Test for error
	bmi	er
exit2	movem.l	(a7)+,d0-a6		;Restore registers
out	rts
	
create	clr.w	-(a7)			;R/W Status
	move.l	a5,-(a7)		;File name
	move.w	#$3c,-(a7)		;Create
	trap	#1
	addq.l	#8,a7
	tst.l	d0
	bmi	er
	move.w	d0,d6
	
write	move.l	a4,-(a7)		;Save address
	move.l	d7,-(a7)		;Length to write
	move.w	d6,-(a7)		;File handle
	move.w	#$40,-(a7)		;Write
	trap	#1
	add.l	#12,A7
	tst.l	d0			;Test for error
	bmi	er
	
close	move.w	d6,-(a7)		;File handle
	move.w	#$3e,-(a7)		;Close
	trap	#1
	addq.l	#4,A7
	tst.l	d0			;Test for error
	bmi	er
	rts

er	moveq	#-1,d0			;-1 = File error
	rts


doname	lea	name(pc),a6	
	move.l	d0,d3			;Start track
	move.l	a0,a5			;Load address
	moveq	#0,D4
	moveq	#0,d5
	lea	ascii(pc),a4
	move.b	d3,d4
	divu	#16,d4	
	move.w	d4,d5
	clr.w	d4
	swap	d4
	move.b	(a4,d5.w),(a6)		;1st digit of file name
	move.b	(a4,d4.w),1(a6)		;2nd digit of file name
	rts


ascii	dc.b	"0123456789ABCDEF"	;Ascii table
	
name	dc.b	"00",0			;File name
	even

	bss
buffer	ds.b	5632			;Space for track

	data
gamecode				;Decrypted game code
	incbin	"reloc.200"
codend	even

******************************************************	

old_sp:	ds.l	1

